#ifndef FAT_FAT_H
#define FAT_FAT_H

#include <stdio.h>

/* The class for the actual FAT! */
class fat_FAT {
public:
    enum {
	fat12_BAD =     0x0ff7,		// bad block
	fat12_EOF =     0x0ff8,
	fat16_BAD =     0xfff7,
	fat16_EOF =     0xfff8,
	fat16_EOF2=     0xffff,		// seen this one too!
	fat32_BAD = 0x0ffffff7,
	fat32_EOF = 0x0ffffff8,
	fatEOF    = fat32_EOF,		// the one we use
	fatBAD    = fat32_BAD
    };
    class clusterchain: public ffs_chain { // a clusterchain is just an FFS chain
    };

    static bool fat_match(class ffs *ffs,
			  sector_t fat0_block,
			  sector_t fat1_block,
			  int sectors,
			  int *matched_sectors=0,int *zero_sectors=0);
    // reports if two fats match
    // fat0 & fat1 are block numbers

    fat_FAT();		
    ~fat_FAT();				// destructor
    ulong  fat_blocks();		// how many blocks are in the FAT?
    ulong fat_zblocks;			// when I read the FAT, how many blocks were all null?
    bool read(class ffs *ffs,		// ffs to read it from
	      sector_t start,		// where to read the FAT
	      class fat_BPB *bpb);	// fat params
					// returns TRUE if successful

    ulong *fat;				// the actual FAT
    ulong clusters;			// the number of clusters in FAT
    int FATType;			// 12, 16 or 32

    bool validate();			// returns TRUE if FAT validates.
    bool equal(class fat_FAT *fat2);	// are two FATs equal?
    cluster_t  next_cluster(cluster_t cluster);	// finds the next cluster; 0 for end
    clusterchain &get_clusterchain(cluster_t cluster); // return the clusterchain starting at cluster
    void get_clusterchain(cluster_t,char *buf,int buflen); // get the clusterchain in a printable form
    void print(FILE *out);
};


#endif
