#include <stdlib.h>
#include "ffs_chain.h"


/****************************************************************
 ****************************************************************
 ***                      chains                              ***
 ****************************************************************
 ****************************************************************/

ffs_chain::ffs_chain()
{
    elems_    = (unsigned int *)malloc(0);
    numelems_ = 0;
}


ffs_chain::~ffs_chain()
{
    //fprintf(stderr,"ffs_chain::~ffs_chain(this=%x)\n",this);
    free(elems_);
}

bool ffs_chain::contains(unsigned int sector_num)
{
    for(int i=0;i<numelems_;i++){
	if(elems_[i]==sector_num) return true;
    }
    return false;
}


/* Add an element to the chain.
 * Return true if success.
 */
bool ffs_chain::add(unsigned int sector_num)
{
    if(contains(sector_num)) return false;	// don't add if we already have

    numelems_++;
    elems_     = (unsigned int *)realloc(elems_,numelems_ * sizeof(int));
    elems_[numelems_-1] = sector_num;
    return true;
}

void ffs_chain::print(FILE *out)
{
    fprintf(out,"Chain elements: %d\n",numelems_);
    for(int i=0;i<numelems_;i++){
	fprintf(out,"%-8d",elems_[i]);
	if(i%8==7) fprintf(out,"\n");
    }
    fflush(out);
}
