#ifndef POS_H
#define POS_H

#include <stdio.h>

/* pos is a position on the disk.
 * It can specify a sector or a cluster.
 * Of course, a cluster only makes sense if we know how many blocks there are per cluster.
 */
class pos {
    bool is_sector_;			// points to a raw sector
    unsigned long sector_;		// where is this located?
    unsigned long cluster_;
    unsigned short offset_; // if I am a cluster, this is a byte offset within
public:;
    pos(unsigned long sector_);
    pos(unsigned long cluster_,unsigned short offset_);
    unsigned long sector(class fat_BPB *); // convert to a sector, using bpb if necessary
    unsigned long cluster();		// returns the cluster
    bool is_sector()  { return is_sector_;}
    bool is_cluster() { return !is_sector_;}
    void fprint(FILE *out);
};



#endif
